Require Import Sets.Finite_sets Ensembles.
SearchAbout Add.

SearchAbout Finite.


Print Finite.

Lemma L0 : forall X : Ensemble nat, Finite _ X -> exists x : nat, ~ X x /\ forall y,
                                                                       X y -> y <= x.
  induction 1.
  exists 42.
  split. 
  destruct 1.
  destruct 1.
  

  destruct IHFinite as [x0 [H1 H2]].
  Require Import Max.

  exists (max (S x) (S x0)).
  split.
  intro.
  About Constructive_sets.Add_inv.
  destruct (Constructive_sets.Add_inv _ A _  _ H3).
  red in H4.
  specialize (H2 _ H4).
  Require Import Omega.
  assert (S x0  <= x0) by eauto with arith. 
  
  omega.
  assert   (S x  <= x) . 
  SearchAbout max. rewrite H4 at 2; apply le_max_l.
  omega. 
  destruct 1.
  transitivity x0.
  auto. 
  transitivity (S x0); eauto with arith. 
  inversion H3.
  transitivity (S x1);
    eauto with arith.
Qed.

Corollary nat_not_finite : ~ Finite _ (Full_set nat).
Proof. 
 intro H. 
 destruct (L0 _ H) as [x [H0 H1]].
 red in H0.  
 apply H0; auto. 
 split. 
Qed.

Require Import Sets.Infinite_sets.

Fixpoint segment (n:nat): Ensemble nat :=
  match n with 0 => Empty_set nat 
            | S n =>  Add nat (segment n) n
  end.


Lemma in_segment: forall n x:nat, (segment n) x <-> x <n.
Proof.
  intro.
  induction n; intro.
  - simpl.
    split;intro.
    + destruct H; auto.
    + contradict H; omega.
  - generalize (IHn x); intro.
    destruct H.
    split;intro.
    + destruct H1.
      * specialize (H H1); omega.
      * destruct H1;auto.
    + apply lt_n_Sm_le in H1.
      apply le_lt_eq_dec in H1;destruct H1.
      * specialize (H0 l).
        apply Union_introl.
        apply H0.
      * apply Union_intror.
        rewrite e.
        apply In_singleton.
Qed.  


Lemma is_finite_segment:
  forall n :nat, Finite nat (segment n).
Proof.
  induction n; unfold segment.
  -  apply Empty_is_finite.
  - apply Add_preserves_Finite.
    trivial.
Qed.

Lemma finite_subset_segment : forall X : Ensemble nat,  (exists x : nat,  forall y, X y -> y < x)
                              -> Finite _ X.
  intros.
  destruct H as [n H]. 
  generalize (in_segment n);intro.
  assert (Included nat X (segment n)).
  +  unfold Included;intros.
     apply (H0 x).
     apply (H x H1).
  + generalize (is_finite_segment  n);intro.
    apply (Finite_downward_closed nat  (segment n) H2 X).
    (*forall A:Ensemble U,
      Finite U A -> forall X:Ensemble U, Included U X A -> Finite U X. *)
    trivial.
    Qed.
      

      
        
