(* Pierre Casteran ,LaBRI et Projet Logical (Inria Futurs) *)

Set Implicit Arguments.

Require Import Relations.
Require Import Classical_sets.

Definition upper_bound (M:Type)
                       (D: Ensemble M)
                       (R:M->M->Prop)
                       (X:Ensemble M)
                       (a:M) :=
                     forall x, D x -> In _ X x -> x=a \/ R x a.


Definition is_lub (M:Type)
                  (D : Ensemble M)
                  (R:M->M->Prop)
                  (X:Ensemble M)
                  (a:M) :=
   D a  /\ upper_bound  D R X a  /\
           (forall y, D y -> upper_bound  D R X y  -> y = a \/ R a y).


Lemma is_lub_ub (M:Type)
                  (D : Ensemble M)
                  (R:M->M->Prop)
                  (X:Ensemble M)
                  (a:M) : is_lub  D R X a -> upper_bound D R X a.
intros.   destruct H. 
now destruct H0.
Qed.



