(*

Add LoadPath ".".
Add LoadPath "../coq".
Require Import Parametricity.

Inductive Computation {A:Type}  : Type :=
| Return (a : A)
| Mult (x y : A) (k : A -> Computation).

Parametricity Computation.
Print  Computation_R.
(* Inductive
Computation_R (A1 A2 : Type) (A_R : A1 -> A2 -> Type)
  : Computation -> Computation -> Type :=
    Return_R : forall (a1 : A1) (a2 : A2),
               A_R a1 a2 -> Computation_R A1 A2 A_R (Return a1) (Return a2)
  | Mult_R : forall (x1 : A1) (x2 : A2),
             A_R x1 x2 ->
             forall (y1 : A1) (y2 : A2),
             A_R y1 y2 ->
             forall (k1 : A1 -> Computation) (k2 : A2 -> Computation),
             (forall (H : A1) (H0 : A2),
              A_R H H0 -> Computation_R A1 A2 A_R (k1 H) (k2 H0)) ->
             Computation_R A1 A2 A_R (Mult x1 y1 k1) (Mult x2 y2 k2)

For Computation_R: Argument scopes are [type_scope type_scope _ _ _]
For Return_R: Argument scopes are [type_scope type_scope _ _ _ _]
For Mult_R: Argument scopes are [type_scope type_scope _ _ _ _ _ _ _ _ _ _]
*)

Print Computation_R_rect.
(*
Computation_R_rect = 
fun (A1 A2 : Type) (A_R : A1 -> A2 -> Type)
  (P : forall c c0 : Computation, Computation_R A1 A2 A_R c c0 -> Type)
  (f : forall (a1 : A1) (a2 : A2) (a_R : A_R a1 a2),
       P (Return a1) (Return a2) (Return_R A1 A2 A_R a1 a2 a_R))
  (f0 : forall (x1 : A1) (x2 : A2) (x_R : A_R x1 x2) 
          (y1 : A1) (y2 : A2) (y_R : A_R y1 y2) (k1 : A1 -> Computation)
          (k2 : A2 -> Computation)
          (k_R : forall (H : A1) (H0 : A2),
                 A_R H H0 -> Computation_R A1 A2 A_R (k1 H) (k2 H0)),
        (forall (a : A1) (a0 : A2) (a1 : A_R a a0),
         P (k1 a) (k2 a0) (k_R a a0 a1)) ->
        P (Mult x1 y1 k1) (Mult x2 y2 k2)
          (Mult_R A1 A2 A_R x1 x2 x_R y1 y2 y_R k1 k2 k_R)) =>
fix F (c c0 : Computation) (c1 : Computation_R A1 A2 A_R c c0) {struct c1} :
  P c c0 c1 :=
  match c1 as c4 in (Computation_R _ _ _ c2 c3) return (P c2 c3 c4) with
  | Return_R _ _ _ a1 a2 a_R => f a1 a2 a_R
  | Mult_R _ _ _ x1 x2 x_R y1 y2 y_R k1 k2 k_R =>
      f0 x1 x2 x_R y1 y2 y_R k1 k2 k_R
        (fun (y : A1) (y0 : A2) (y1 : A_R y y0) =>
         F (k1 y) (k2 y0) (k_R y y0 y1))
  end
     : forall (A1 A2 : Type) (A_R : A1 -> A2 -> Type)
         (P : forall c c0 : Computation, Computation_R A1 A2 A_R c c0 -> Type),
       (forall (a1 : A1) (a2 : A2) (a_R : A_R a1 a2),
        P (Return a1) (Return a2) (Return_R A1 A2 A_R a1 a2 a_R)) ->
       (forall (x1 : A1) (x2 : A2) (x_R : A_R x1 x2) 
          (y1 : A1) (y2 : A2) (y_R : A_R y1 y2) (k1 : A1 -> Computation)
          (k2 : A2 -> Computation)
          (k_R : forall (H : A1) (H0 : A2),
                 A_R H H0 -> Computation_R A1 A2 A_R (k1 H) (k2 H0)),
        (forall (a : A1) (a0 : A2) (a1 : A_R a a0),
         P (k1 a) (k2 a0) (k_R a a0 a1)) ->
        P (Mult x1 y1 k1) (Mult x2 y2 k2)
          (Mult_R A1 A2 A_R x1 x2 x_R y1 y2 y_R k1 k2 k_R)) ->
       forall (c c0 : Computation) (c1 : Computation_R A1 A2 A_R c c0),
       P c c0 c1

Argument scopes are [type_scope type_scope _ _ _ _ _ _ _]
*)

Print Mult_R.
(*
Inductive
Computation_R (A1 A2 : Type) (A_R : A1 -> A2 -> Type)
  : Computation -> Computation -> Type :=
    Return_R : forall (a1 : A1) (a2 : A2),
               A_R a1 a2 -> Computation_R A1 A2 A_R (Return a1) (Return a2)
  | Mult_R : forall (x1 : A1) (x2 : A2),
             A_R x1 x2 ->
             forall (y1 : A1) (y2 : A2),
             A_R y1 y2 ->
             forall (k1 : A1 -> Computation) (k2 : A2 -> Computation),
             (forall (H : A1) (H0 : A2),
              A_R H H0 -> Computation_R A1 A2 A_R (k1 H) (k2 H0)) ->
             Computation_R A1  A2  A_R (Mult x1 y1 k1) (Mult x2 y2 k2)

For Computation_R: Argument scopes are [type_scope type_scope _ _ _]
For Return_R: Argument scopes are [type_scope type_scope _ _ _ _]
For Mult_R: Argument scopes are [type_scope type_scope _ _ _ _ _ _ _ _ _ _]
*)

*)