(**  Solution to an exercise *)
   

Require Import Arith Relations.

Theorem lt_wf : well_founded lt.
Proof.
  intro n; induction n as [ | p IHp].
  - split; intros y Hy; inversion_clear Hy.
  - split; intros y Hy.
    inversion_clear    Hy .  
    + assumption.
    + assert (y < p) by  auto with arith.
      destruct IHp; auto.
Qed.


Definition R (n p :nat) := 0 < n /\ p = 2 * n.

Require Import Wellfounded.Inclusion Omega.

Lemma Rwf : well_founded R.
Proof.
  apply wf_incl with lt.
  - intros n p  [H H0].
    omega.
  - apply lt_wf.
Qed.


Require Import List.
Open Scope list_scope.


Inductive strict_prefix (A:Type)  : relation (list A) :=
  strict_prefix_intro : forall  (a:A) l l',  strict_prefix _  l (l ++ (a::l')).
Arguments strict_prefix_intro {A} _ _ _.

Require Import Inverse_Image.


Theorem strict_prefix_wf {A:Type} : well_founded (strict_prefix A).
Proof.
  apply wf_incl with (fun l l' =>  length l < length l').
  - intros l l' H.  destruct H as [a].
    SearchRewrite (length (_ ++ _)).
    rewrite app_length;cbn; omega.
  - apply wf_inverse_image, lt_wf.
Qed.

Require Import Simple_LexProd.

Theorem lt2_wf : well_founded (lexico lt (lexico lt lt)).
Proof.
 repeat apply wf_lexico; apply  lt_wf.
Qed.

